/*GPL*START*
 * 
 * Copyright (C) 1998 by Johannes Overmann <overmann@iname.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * *GPL*END*/  

#ifndef _loadgraph_h_
#define _loadgraph_h_

#include <qwidget.h>
#include <qpixmap.h>
#include <qcolor.h>
#include <qpopmenu.h>

#include "machine.h"
#include "tarray.h"

#define Qjo_loadgraph_NUM_COLORS 10

class LoadGraph: public QWidget {
   
   Q_OBJECT;
   
 public:
   // cons & des
   LoadGraph(QWidget *parent, bool grid, bool reverse, int num, const TString& title, Machine *mach=0);
   ~LoadGraph();

   // main interface
   bool isEmpty() const {return m.num()==0;}
   void addMachine(Machine *mach) {m += mach;}
   void dataChanged() {isdirty=true;}
   
 
 public slots:
   void popact(int i);
   
 signals:
   void is_empty();
   
 protected:
   void paintEvent(QPaintEvent *);
   void resizeEvent(QResizeEvent *p);
   void mousePressEvent(QMouseEvent *e);

 private:
   void drawgraph();
   double load(int mach, int back);

   
   TArray<Machine *> m;  // machines to display
   bool grid;
   int num;
   TString title;
   bool isdirty;
   QColor c_border;
   QColor c_bg;
   QColor c_fg; // text
   QColor c_grid;
   QColor c_graph[Qjo_loadgraph_NUM_COLORS];
   QPixmap *pix;
   QPopupMenu *pop;
};


#endif
